;    Developer: Xtreme (Andrew M. Barfield)
;        Email: abarfield@ec.rr.com
;         Date: January 27, 2004
;      Subject: SHDOCVW.DLL Web Browser Control
; Distribution: Win32ASM Community and MasmForum
;      License: Public/Free
;        Notes: Repost of the original Web Browser Control sample



      .586                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive

      include Browser.inc       ; local includes for this file
      
.code





start:

    ; Store the Instance Handle
        invoke GetModuleHandle, NULL
        mov hInstance, eax


    ; Store the Application Icon
        ;invoke LoadIcon,hInstance,500
        ;mov hIcon, eax


    ; Store the Default Mouse Cursor
        invoke LoadCursor,NULL,IDC_ARROW
        mov hCursor, eax


    ; Initialize the COM Library
        invoke CoInitialize, NULL


    ; Start the Application
        call Main
      
    ; Uninitialize the COM Library
        invoke CoUninitialize

    ; Exit
        invoke ExitProcess,eax





Main proc

    ; Register the Main Window Class
        szText szClassName,"Browser_Class"
        invoke RegisterWinClass,ADDR WndProc,ADDR szClassName, hIcon,hCursor,COLOR_BTNFACE+1


    ; Create the Main Window
        invoke CreateWindowEx,WS_EX_LEFT, ADDR szClassName, ADDR szDisplayName, WS_OVERLAPPEDWINDOW, 50,50,600,400, NULL,NULL, hInstance,NULL
        mov hWnd,eax


    ; Create the MS Web Browser COM Object
        invoke CreateWebBrowser, hWnd, 0    ; 0 = StatusBar hWnd


    ; Show the Window
        DisplayWindow hWnd,SW_SHOWMAXIMIZED


    ; Begin the Message Loop
        call MsgLoop
        ret

Main endp





RegisterWinClass proc lpWndProc:DWORD, lpClassName:DWORD, Icon:DWORD, Cursor:DWORD, bColor:DWORD

    ; Create a Main Window Class
        LOCAL wc:WNDCLASSEX
        mov wc.cbSize,         sizeof WNDCLASSEX
        mov wc.style,          CS_BYTEALIGNCLIENT or CS_BYTEALIGNWINDOW
        m2m wc.lpfnWndProc,    lpWndProc
        mov wc.cbClsExtra,     NULL
        mov wc.cbWndExtra,     NULL
        m2m wc.hInstance,      hInstance
        m2m wc.hbrBackground,  bColor
        mov wc.lpszMenuName,   NULL
        m2m wc.lpszClassName,  lpClassName
        m2m wc.hIcon,          NULL
        m2m wc.hCursor,        Cursor
        m2m wc.hIconSm,        NULL
        invoke RegisterClassEx, ADDR wc
        ret

RegisterWinClass endp





MsgLoop proc

    ; Get OS Messages
        LOCAL msg:MSG
        StartLoop:
            invoke GetMessage,ADDR msg,NULL,0,0
            cmp eax, 0
            je ExitLoop
            invoke TranslateMessage, ADDR msg
            invoke DispatchMessage,  ADDR msg
            jmp StartLoop
        ExitLoop:


    ; Return to the OS the last recieved message
        mov eax, msg.wParam
        ret

MsgLoop endp





WndProc proc hWin   :DWORD, uMsg   :DWORD, wParam :DWORD, lParam :DWORD

    ; Handle OS Messages
        .if uMsg == WM_SIZE
                invoke ResizeWebBrowser
                return 0

        .elseif uMsg == WM_DESTROY
                invoke CleanupWebBrowser
                invoke PostQuitMessage,NULL
                return 0

        .endif

        invoke DefWindowProc,hWin,uMsg,wParam,lParam
        ret

WndProc endp


end start

